program SONDA;
uses Crt,Dos,Graph,Mouselib,
     Bitmap, Winres, Objects;

{$M 4096,0,130000}
{$R+;$S+;$I+;$D+;$V+}

const
  BFMAX         = 5000;
  BSMAX         = 650;
  NUMMARK       = 2;

  cmQuit        = 0;
  cmLeft        = 1;
  cmRight       = 2;
  cmOptions     = 3;
  cmEnd         = 4;
  cmBegin       = 5;
  cmXup         = 6;
  cmXdown       = 7;
  cmYup         = 8;
  cmYdown       = 9;
  cmNewData     = 10;
  cmRealTime    = 11;
  cmCalibrate   = 12;
  cmHelp        = 13;
  cmLogo        = 14;
  cmMoveMouse   = 15;
  cmSave        = 16;
  cmLoad        = 17;

  cmM1up        = 20;
  cmM1down      = 21;
  cmM1put       = 22;
  cmM1volt      = 23;
  cmM2up        = 24;
  cmM2down      = 25;
  cmM2put       = 26;
  cmM2volt      = 27;

  cmDistance1   = 40;
  cmNil         = 255;

  WX1           = 160;
  WY1           = 330;
  WX2           = 480;
  WY2           = 420;

  ROH           = 4;

type
  TBUTON = record
             X1,Y1,X2,Y2,
             butoncolor,textcolor,
             textsize,roh           : integer;
             command                : byte;
             text                   : string;
           end;
var
  COM                  : array [0..1] of word absolute $0000:$0400;
  NUM                  : byte;
  HL,DELKA,HOD,MIN,SEC            : word;
  DATA,INTE,INTF,CONT,PFC,PFD,PFE : word;
  VOLT,VZORKU,ASTR,DIS1           : string;
  MVOLT                           : array [1..NUMMark] of string[20];
  HHH,MMM,VVV,SSS,NVZ             : word;
  CAS,STCAS,TIMDIV                : real;
  A                               : char;
  CNT                             : integer;

  XM,YM,WSIZE                     : integer;
  BUFFER                          : array [1..BFMAX] of byte;
  BUFPOS,KROK,LBUF                : integer;
  BUFSCR                          : array [1..BSMAX] of word;
  ZOOMX,ZOOMY,KRZOOMX,KRZOOMY     : real;

  MARKER                          : array [1..NUMMARK] of integer;
  BUFMAR                          : array [1..NUMMARK] of integer;
  KRMARKER                        : byte;

  LCM,CLCM,KLCM,DLCM              : byte;

  FS,FSM,FSD,Konec                : boolean;
  FSV1,FSV2                       : boolean;

  IML                             : word;
  IMP                             : pointer;

  BUTON                           : array [1 .. 30] of TBUTON;
  NUMBUT                          : byte;

  EXTFILE                         : file;

{****************************************************************************}
{ nastaveni a obsluha serioveho portu                                        }
{****************************************************************************}
procedure SETCOM;
begin
  NUM:=0;
  DATA:=COM[NUM];
  INTE:=COM[NUM]+1;
  INTF:=COM[NUM]+2;
  CONT:=COM[NUM]+3;
  PFC:=COM[NUM]+4;
  PFD:=COM[NUM]+5;
  PFE:=COM[NUM]+6;
  port[PFC]:=$01;
  port[CONT]:=128;
  port[DATA]:=1;  {ZDE JE DELITEL}
  port[INTE]:=0;
  port[CONT]:=7;
  HL:=port[PFD];HL:=port[DATA];
  port[INTE]:=0;
end;

function SEM:byte;
begin
  repeat until (keypressed or ((port[PFD] and 1) = 1));
  SEM:=port[DATA];{round(255*random);}                {port[DATA];}
end;

{****************************************************************************}
{ GRAFICKE ZOBRAZENI ANALIZATORU                                             }
{****************************************************************************}
procedure SHOWBUTON(N,STAV:byte);
var
  BTX,BTY : integer;
begin
  with BUTON[N] do begin
                     settextstyle(0,0,textsize);
                     setcolor(butoncolor);
                     line(X1+roh,Y1,X2-roh,Y1);line(X2-roh,Y1,X2,Y1+roh);
                     line(X2,Y1+roh,X2,Y2-roh);line(X2,Y2-roh,X2-roh,Y2);
                     line(X2-roh,Y2,X1+roh,Y2);line(X1+roh,Y2,X1,Y2-roh);
                     line(X1,Y2-roh,X1,Y1+roh);line(X1,Y1+roh,X1+roh,Y1);
                     setfillstyle(1,butoncolor);
                     floodfill(X1 + (X2-X1) shr 1,Y1 + 2,butoncolor);
                     BTX:=textsize + X1 + (X2 - X1 - textwidth(text)) shr 1;
                     BTY:=Y1 + (Y2 - Y1 - textheight(text)) shr 1;
                     setcolor(textcolor);
                     outtextxy(BTX,BTY+2,text);
                     if (command=cmDistance1) or
                        (command=cmM1volt   ) or
                        (command=cmM2volt   )
                                            then setcolor(butoncolor)
                                            else setcolor(lightblue);
                     if STAV=0 then begin
                                      line(X2,Y1+roh,X2,Y2-roh);
                                      line(X2,Y2-roh,X2-roh,Y2);
                                      line(X2-roh,Y2,X1+roh,Y2);
                                      line(X1+roh,Y2,X1,Y2-roh);
                                    end
                               else begin
                                      line(X1,Y2-roh,X1,Y1+roh);
                                      line(X1,Y1+roh,X1+roh,Y1);
                                      line(X1+roh,Y1,X2-roh,Y1);
                                      line(X2-roh,Y1,X2,Y1+roh);
                                    end;
                   end;
end;

procedure PANEL;
begin
  setcolor(15);
  rectangle(0,1,XM,259);
  rectangle(1,0,XM-1,260);
  for CNT:=1 to NUMBUT do SHOWBUTON(CNT,0);
  setcolor(red);rectangle(WX1,WY1,WX2,WY2);
end;

procedure SHOWDISTANCE;
begin
  CNT:=0;
  repeat
    inc(CNT);
  until BUTON[CNT].command=cmDistance1;
  FSD:=false;
  settextstyle(0,0,1);
  setcolor(green);outtextxy(BUTON[CNT].X1+15,BUTON[CNT].Y1+4,DIS1);
  CAS:=abs((MARKER[1]-MARKER[2])*TIMDIV);
  str(CAS:1:3,DIS1);DIS1:=DIS1+' s';
  setcolor(yellow);outtextxy(BUTON[CNT].X1+15,BUTON[CNT].Y1+4,DIS1);
end;

procedure SHOWVOLT(N:byte);
var
  CM : byte;
begin
  CNT:=0;
  case N of
    1  : begin
           CM:=cmM1volt;
           FSV1:=false
         end;
    2  : begin
           CM:=cmM2volt;
           FSV2:=false
         end;
  end;
  repeat
    inc(CNT);
  until BUTON[CNT].command=CM;
  FSD:=false;
  settextstyle(0,0,1);
  setcolor(green);outtextxy(BUTON[CNT].X1+15,BUTON[CNT].Y1+4,MVOLT[N]);

  HL:=BUFFER[MARKER[N]];

  str(5*(255-HL)/256:1:2,MVOLT[N]);MVOLT[N]:=MVOLT[N]+' V';

  setcolor(yellow);outtextxy(BUTON[CNT].X1+15,BUTON[CNT].Y1+4,MVOLT[N]);
end;

procedure SHOWMARK;
begin
  for CNT:=1 to NUMMARK do
  begin
    if BUFMAR[CNT]<>0 then
    begin
      setcolor(0);
      line(BUFMAR[CNT],2,BUFMAR[CNT],258);
    end;
  end;
  for CNT:=1 to NUMMARK do
  begin
    if (MARKER[CNT]>=BUFPOS)and(MARKER[CNT]<=BUFPOS+WSIZE) then
    begin
      setcolor(CNT+10);
      line(MARKER[CNT]-BUFPOS+2,2,MARKER[CNT]-BUFPOS+2,258);
      BUFMAR[CNT]:=MARKER[CNT]-BUFPOS+2;
    end
    else BUFMAR[CNT]:=0;
  end;
  FSM:=false;
end;

procedure SHOW;
var
  CNT,Y : word;
begin
  for CNT:=1 to WSIZE do begin
                           putpixel(CNT+1,BUFSCR[CNT],0);
                           Y:=BUFFER[BUFPOS+CNT]+2;
                           putpixel(CNT+1,Y,15);
                           BUFSCR[CNT]:=Y;
                         end;
  FS:=false;
end;

{****************************************************************************}
{ VYKONNE PROCEDURY ANALIZATORU                                              }
{****************************************************************************}
procedure GETWIN;
begin
  IML:=imagesize(WX1,WY1,WX2,WY2);
  getmem(IMP,IML);
  getimage(WX1,WY1,WX2,WY2,IMP^);
end;

procedure PUTWIN;
begin
  putimage(WX1,WY1,IMP^,copyput);
  freemem(IMP,IML);
end;

procedure CALIBRATE;
begin
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    RIGHT_BUTTON_PRESSED);
  GETWIN;
  setcolor(14);
  ASTR:='Press a key to stop statistic ... ';
  outtextxy(WX1+20,WY1+20,ASTR);
  GetTime(HHH,MMM,VVV,SSS);
  STCAS:=3600*HHH+60*MMM+VVV+SSS/100;
  NVZ:=0;VZORKU:='';
  repeat
    HL:=SEM;
    inc(NVZ);
  until KeyPressed or eventHappened or (NVZ=10000);
  GetTime(HHH,MMM,VVV,SSS);
  CAS:=3600*HHH+60*MMM+VVV+SSS/100-STCAS;
  if CAS>0 then str(NVZ/CAS:6:2,VZORKU);
  str(5*(255-HL)/256:1:2,VOLT);
  VOLT:='napeti : '+VOLT+'V';
  outtextxy(WX1+20,WY1+40,VOLT);
  VZORKU:='vzorku/vterinu : '+VZORKU+'    ';
  outtextxy(WX1+20,WY1+60,VZORKU);
  if KeyPressed then ReadKey;
  eventHappened:=false;
  repeat
  until KeyPressed or eventHappened;
  if KeyPressed then ReadKey;
  eventHappened:=false;
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    LEFT_BUTTON_RELEASED +
                    RIGHT_BUTTON_PRESSED);
  PUTWIN;
end;

procedure OPTIONS;
begin
end;

procedure NEWDATA;
begin
  for CNT :=1 to LBUF do begin
                           BUFFER[CNT]:=SEM;{round(20+10*random+100*(1+sin(pi*CNT/200)));}
                         end;
  FS:=true;FSM:=true;FSD:=true;
  FSV1:=true;FSV2:=true;
end;

procedure LEFT;
begin
  BUFPOS:=BUFPOS-KROK*KLCM;
  if BUFPOS<1 then BUFPOS:=1;
  FS:=true;FSM:=true;FSD:=true;
  FSV1:=true;FSV2:=true;
end;

procedure RIGHT;
begin
  BUFPOS:=BUFPOS+KROK*KLCM;
  if BUFPOS+WSIZE>LBUF then BUFPOS:=LBUF-WSIZE;
  FS:=true;FSM:=true;FSD:=true;
  FSV1:=true;FSV2:=true;
end;

procedure PLUSX;
begin
  ZOOMX:=ZOOMX*KRZOOMX;
end;

procedure MINUSX;
begin
  ZOOMX:=ZOOMX/KRZOOMX;
end;

procedure PLUSY;
begin
  ZOOMY:=ZOOMY*KRZOOMY;
end;

procedure MINUSY;
begin
  ZOOMY:=ZOOMY/KRZOOMY;
end;

procedure PLUSMARKER(NUM:byte);
begin
  case NUM of
    1 : FSV1:=true;
    2 : FSV2:=true;
  end;
  FSD:=true;
  FSM:=true;
  FS:=true;
  MARKER[NUM]:=MARKER[NUM]+KRMARKER*KLCM;
  if MARKER[NUM]>LBUF then MARKER[NUM]:=LBUF;
end;

procedure MINUSMARKER(NUM:byte);
begin
  case NUM of
    1 : FSV1:=true;
    2 : FSV2:=true;
  end;
  FSD:=true;
  FSM:=true;
  FS:=true;
  MARKER[NUM]:=MARKER[NUM]-KRMARKER*KLCM;
  if MARKER[NUM]<1 then MARKER[NUM]:=1;
end;

procedure QUIT;
begin
  IML:=imagesize(160,10,480,250);
  getmem(IMP,IML);
  getimage(160,10,480,250,IMP^);
  setcolor(14);
  outtextxy(170,100,'      Have you already finished');
  outtextxy(170,120,'         all your measures ?');
  outtextxy(170,140,'              (Yes/No)');
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    RIGHT_BUTTON_PRESSED);
  eventHappened := false;

  repeat until KeyPressed or eventHappened;
  if (getButton(leftButton)  = buttonDown) then A:='y';
  if (getButton(rightButton) = buttonDown) then A:='n';
  if KeyPressed then A:=Readkey;
  if (A='a') or (A='A') or
     (A='y') or (A='Y') then Konec:=true;
  putimage(160,10,IMP^,copyput);
  freemem(IMP,IML);
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    LEFT_BUTTON_RELEASED +
                    RIGHT_BUTTON_PRESSED);
  eventHappened := false;
end;

procedure REALTIME;
begin
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    RIGHT_BUTTON_PRESSED);
  repeat for CNT:=1 to WSIZE do begin
                                  putpixel(CNT+1,BUFSCR[CNT],0);
                                  BUFSCR[CNT]:=SEM+2;
                                  putpixel(CNT+1,BUFSCR[CNT],15);
                                end;
  until KeyPressed or eventHappened;
  if Keypressed then ReadKey;
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    LEFT_BUTTON_RELEASED +
                    RIGHT_BUTTON_PRESSED);
  eventHappened := false;
end;

procedure MOVEMOUSE;
var
  X : word;
begin
  X:=getMouseX;
  showMouseCursor;
  repeat
    BUFPOS:=BUFPOS+getMouseX-X;
    if BUFPOS<1 then BUFPOS:=1;
    if BUFPOS+WSIZE>LBUF then BUFPOS:=LBUF-WSIZE;
    SHOW;
    SHOWMARK;
  until eventHappened;
  eventHappened:=false;
  hideMouseCursor;
  FS:=true;FSM:=true;FSD:=true;
  FSV1:=true;FSV2:=true;
end;

procedure SAVE;
begin
  assign(EXTFILE,'zzz.son');
  rewrite(EXTFILE,1);
  blockwrite(EXTFILE,BUFFER,LBUF);
  close(EXTFILE);
end;

procedure LOAD;
begin
  assign(EXTFILE,'zzz.son');
  reset(EXTFILE,1);
  blockread(EXTFILE,BUFFER,LBUF);
  close(EXTFILE);
  FS:=true;FSM:=true;FSD:=true;
  FSV1:=true;FSV2:=true;
end;

{****************************************************************************}
{ INICIALIZACE PROMENNYCH ANALIZATORU                                        }
{****************************************************************************}
procedure DEFINEBUTON(X1,Y1,X2,Y2:integer;text:string;
                      butoncolor,textcolor,textsize,roh,command:integer);
begin
  inc(NUMBUT);
  BUTON[NUMBUT].X1:=X1;BUTON[NUMBUT].Y1:=Y1;
  BUTON[NUMBUT].X2:=X2;BUTON[NUMBUT].Y2:=Y2;
  BUTON[NUMBUT].butoncolor:=butoncolor;
  BUTON[NUMBUT].textcolor:=textcolor;
  BUTON[NUMBUT].textsize:=textsize;
  BUTON[NUMBUT].text:=text;
  BUTON[NUMBUT].roh:=roh;
  BUTON[NUMBUT].command:=command;
end;

procedure INIT;
begin
  XM:=GetMaxX;YM:=GetMaxY;
  settextstyle(0,0,1);
  LBUF:=BFMAX;
  BUFPOS:=1;
  KROK:=1;
  WSIZE:=XM-4;
  KRZOOMX:=2;KRZOOMY:=2;KRMARKER:=1;
  ZOOMX:=1;ZOOMY:=1;
  for HL:=1 to WSIZE do BUFSCR[HL]:=10;
  for HL:=1 to NUMMARK do MARKER[HL]:=50*HL;
  for HL:=1 to NUMMARK do BUFMAR[HL]:=50*HL+2;
  for HL:=1 to NUMMARK do MVOLT[HL]:='';
  TIMDIV:=1/481;
  LCM:=cmNil;CLCM:=0;
  KLCM:=1;DLCM:=0;
  FS:=false;FSM:=false;FSD:=false;
  FSV1:=false;FSV2:=false;
  DIS1:='';
  NUMBUT:=0;
  DEFINEBUTON(10 ,280,130,320,'Begin'    ,blue ,yellow,2,ROH,cmBegin);
  DEFINEBUTON(140,280,210,320,'<<<'      ,blue ,yellow,2,ROH,cmLeft);
  DEFINEBUTON(220,280,290,320,'< >'      ,blue ,yellow,2,ROH,cmMoveMouse);
  DEFINEBUTON(300,280,370,320,'>>>'      ,blue ,yellow,2,ROH,cmRight);
  DEFINEBUTON(380,280,480,320,'End'      ,blue ,yellow,2,ROH,cmEnd);
  DEFINEBUTON(590,330,630,370,'x+'       ,blue ,yellow,2,ROH,cmXup);
  DEFINEBUTON(490,330,530,370,'x-'       ,blue ,yellow,2,ROH,cmXdown);
  DEFINEBUTON(540,280,580,320,'y+'       ,blue ,yellow,2,ROH,cmYup);
  DEFINEBUTON(540,380,580,420,'y-'       ,blue ,yellow,2,ROH,cmYdown);
  DEFINEBUTON(10 ,330,150,370,'New data' ,blue ,yellow,2,ROH,cmNewData);
  DEFINEBUTON(10 ,380,150,420,'RealTime' ,blue ,yellow,2,ROH,cmRealTime);
  DEFINEBUTON(10 ,430,100,470,'Quit'     ,blue ,red   ,2,ROH,cmQuit);
  DEFINEBUTON(110,430,270,470,'Calibrate',blue ,green ,2,ROH,cmCalibrate);
  DEFINEBUTON(280,430,360,470,'Help'     ,blue ,green ,2,ROH,cmHelp);
  DEFINEBUTON(370,430,450,470,'loGo'     ,blue ,green ,2,ROH,cmLogo);
  DEFINEBUTON(460,430,540,470,'Save'     ,blue ,cyan  ,2,ROH,cmSave);
  DEFINEBUTON(550,430,630,470,'Load'     ,blue ,cyan  ,2,ROH,cmLoad);
  DEFINEBUTON(10 ,262,90 ,276,''         ,green,green ,1,2  ,cmDistance1);
  DEFINEBUTON(100,262,180,276,'>        ',green,11    ,1,2  ,cmM1volt);
  DEFINEBUTON(190,262,270,276,'>        ',green,12    ,1,2  ,cmM2volt);
end;

{****************************************************************************}
{ INICIALIZACE GRAFIKY ANALIZATORU                                           }
{****************************************************************************}
procedure EGAVGA;external;
{$L egavga}

function GRAFIKA : boolean;
var
  grDriver,grMode,ErrCode : integer;
  BGIF : file;
  BGIP : pointer;
begin
  GRAFIKA:=false;
  BGIP:=@EGAVGA;
  if registerbgidriver(BGIP) < 0 then writeln(grapherrormsg(graphresult));
  DetectGraph(grDriver,grMode);
  InitGraph(grDriver,grMode,'');
  errCode:=GraphResult;
  if errCode=grOk then GRAFIKA:=true
                  else writeln(GraphErrorMsg(ErrCode));
end;

{****************************************************************************}
{ LOGO                                                                       }
{****************************************************************************}
procedure LOGO(X,Y:word);
var
  A,B   : word;
  Image : pointer;
  s: PStream;
begin
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    RIGHT_BUTTON_PRESSED);
  IML:=imagesize(X,Y,X+320,Y+240);
  getmem(IMP,IML);
  getimage(X,Y,X+320,Y+240,IMP^);
  s := new(pdosstream,Init('sonda.bmp', stOpenRead));
  Image := Loadbitmapfileimg(s^);
  Dispose(s, done);
  freemem(image,38406);
  If Image <> nil then PutImage(X,Y,Image^,normalput);
  repeat until KeyPressed or eventHappened;
  if KeyPressed then Readkey;
  putimage(X,Y,IMP^,copyput);
  freemem(IMP,IML);
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    LEFT_BUTTON_RELEASED +
                    RIGHT_BUTTON_PRESSED);
  eventHappened := false;
end;

{****************************************************************************}
{ HELP                                                                       }
{****************************************************************************}
procedure HELP;
var
  d, m: integer;
  Image: pointer;
begin
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    RIGHT_BUTTON_PRESSED);
  IML:=imagesize(160,10,480,250);
  getmem(IMP,IML);
  getimage(160,10,480,250,IMP^);
  setcolor(14);
  outtextxy(170,20 ,'F1,H  ... help        Q ... Quit');
  outtextxy(170,40 ,'Move with data window');
  outtextxy(170,50 ,'B     ... Begin       E ... End');
  outtextxy(170,60 ,'<-    ... Left        -> .. Right');
  outtextxy(170,80 ,'N ... New data        C ... Calibration');
  outtextxy(170,90 ,'R ... Realtime loop');
  outtextxy(170,100,'G ... loGo            H ... Help');
  outtextxy(170,120,'Disk operations');
  outtextxy(170,130,'S ... Save            L ... Load');
  outtextxy(170,150,'Mouse control is a bit wider');
  outtextxy(170,160,'Right and left butons are used. Special');
  outtextxy(170,170,'function is moving markers by clicking');
  outtextxy(170,180,'just under the bottom border of display');

  outtextxy(170,200,'        (c) Petr Simandl 1997');
  outtextxy(170,210,'         Osciloscop-Analyzer');

  repeat until KeyPressed or eventHappened;
  if KeyPressed then Readkey;
  putimage(160,10,IMP^,copyput);
  freemem(IMP,IML);
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    LEFT_BUTTON_RELEASED +
                    RIGHT_BUTTON_PRESSED);
  eventHappened := false;
end;

{****************************************************************************}
{ PROCEDURY VSTUPU MYSI A KLAVESNICE                                         }
{****************************************************************************}
procedure INITMYS;
begin
  if not (mouse_present) then begin
                                write('mouse not installed');
                                delay(1000);
                              end;
  setMouseGraph;
  initMouse;
  mousebox(0,260,XM,YM);
  showMouseCursor;
  setDefaultHandler(LEFT_BUTTON_PRESSED +
                    LEFT_BUTTON_RELEASED +
                    RIGHT_BUTTON_PRESSED);
  eventHappened := false;
  hideMouseCursor;
end;

function FINDCMD:byte;
var
  X,Y : word;
  HIT : boolean;
begin
  X:=getMouseX;
  Y:=getMouseY;
  CNT:=0;
  repeat
    inc(CNT);HIT:=true;
    if X<BUTON[CNT].X1 then HIT:=false;
    if Y<BUTON[CNT].Y1 then HIT:=false;
    if X>BUTON[CNT].X2 then HIT:=false;
    if Y>BUTON[CNT].Y2 then HIT:=false;
  until HIT or (CNT=NUMBUT+1);
  if CNT<NUMBUT+1 then FINDCMD:=BUTON[CNT].command
                  else begin
                         FINDCMD:=cmNil;
                         if (Y=260) and (getButton(leftButton) = buttonDown)
                           then begin
                                  FSV1:=true;FSD:=true;FSM:=true;
                                  MARKER[1]:=BUFPOS+X-2;
                                  if MARKER[1]>LBUF then MARKER[1]:=LBUF;
                                  if MARKER[1]<1    then MARKER[1]:=1;
                                end;
                         if (Y=260) and (getButton(rightButton) = buttonDown)
                           then begin
                                  FSV2:=true;FSD:=true;FSM:=true;
                                  MARKER[2]:=BUFPOS+X-2;
                                  if MARKER[2]>LBUF then MARKER[2]:=LBUF;
                                  if MARKER[2]<1    then MARKER[2]:=1;
                                end;
                       end;
end;

function MYS:byte;
begin
  if (getButton(leftButton) = buttonDown) or
     (getButton(rightButton) = buttonDown  ) then begin
                                                    MYS:=FINDCMD;
                                                  end
                                             else MYS:=cmNil;
end;

procedure NORMKEYS(var KCM : byte);
begin
  case A of
    'q','Q'    : KCM:=cmQuit;
    'o','O'    : KCM:=cmOptions;
    'r','R'    : KCM:=cmRealtime;
    's','S'    : KCM:=cmSave;
    'l','L'    : KCM:=cmLoad;
    'e','E'    : KCM:=cmEnd;
    'b','B'    : KCM:=cmBegin;
    'n','N'    : KCM:=cmNewData;
    'c','C'    : KCM:=cmCalibrate;
    'h','H'    : KCM:=cmHelp;
    'g','G'    : KCM:=cmLogo;
    '1'        : KCM:=cmM1up;
    '2'        : KCM:=cmM1down;
    '3'        : KCM:=cmM2up;
    '4'        : KCM:=cmM2down;
  end;
end;

procedure EXTKEYS(var KCM : byte);
begin
  A:=ReadKey;
  case A of
    'K'        : KCM:=cmLeft;
    'M'        : KCM:=cmRight;
    'H'        : KCM:=cmYup;
    'P'        : KCM:=cmYdown;
    ';'        : KCM:=cmHelp;
  end;
end;

function KEYMOUSE : byte;
var
  KCM : byte;
begin
  showMouseCursor;
  DLCM:=0;
  repeat
    inc(DLCM);delay(1);
    if DLCM>100 then begin
                        LCM:=cmNil;KLCM:=1;
                        DLCM:=0;CLCM:=0;
                      end;
  until KeyPressed or eventHappened;
  if eventHappened then begin
                          eventHappened := false;
                          KEYMOUSE:=MYS;
                          KLCM:=200;
                        end
                   else begin
                          A:=readkey;
                          if A=chr(0) then EXTKEYS(KCM)
                                      else NORMKEYS(KCM);
                          if KCM=LCM then begin
                                            inc(CLCM);
                                            if CLCM>5 then KLCM:=CLCM-5
                                                      else KLCM:=1;
                                          end
                                     else begin
                                            CLCM:=0;KLCM:=1;
                                            LCM:=KCM;
                                          end;
                          KEYMOUSE:=KCM;
                        end;
  hideMouseCursor;
end;

{****************************************************************************}
{ HLAVNI CAST PROGRAMU                                                       }
{****************************************************************************}
begin
  writeln;
  Konec:=false;
  if GRAFIKA then begin
                    INIT;
                    SETCOM;
                    INITMYS;
                    LOGO(160,120);
                    PANEL;
{                    NEWDATA;SHOW;SHOWMARK;SHOWDISTANCE;
                    SHOWVOLT(1);SHOWVOLT(2);
}                    repeat
                      case KEYMOUSE of
                        cmBegin      : begin
                                         FS:=true;FSM:=true;
                                         LCM:=cmBegin;CLCM:=0;
                                         BUFPOS:=1;
                                       end;
                        cmEnd        : begin
                                         FS:=true;FSM:=true;
                                         LCM:=cmEnd;CLCM:=0;
                                         BUFPOS:=LBUF-WSIZE;
                                       end;
                        cmRealTime   : REALTIME;
                        cmCalibrate  : CALIBRATE;
                        cmOptions    : OPTIONS;
                        cmNewData    : NEWDATA;
                        cmXup        : PLUSX;
                        cmXdown      : MINUSX;
                        cmLeft       : LEFT;
                        cmRight      : RIGHT;
                        cmYup        : PLUSY;
                        cmYdown      : MINUSY;
                        cmM1up       : MINUSMARKER(1);
                        cmM1down     : PLUSMARKER(1);
                        cmM2up       : MINUSMARKER(2);
                        cmM2down     : PLUSMARKER(2);
                        cmQuit       : QUIT;
                        cmHelp       : HELP;
                        cmLogo       : LOGO(160,5);
                        cmMoveMouse  : MOVEMOUSE;
                        cmLoad       : LOAD;
                        cmSave       : SAVE;
                      end;
                      if FSM  then SHOWMARK;
                      if FS   then SHOW;
                      if FSD  then SHOWDISTANCE;
                      if FSV1 then SHOWVOLT(1);
                      if FSV2 then SHOWVOLT(2);
                    until Konec;
                    CloseGraph;
                  end;
end.
